program kulki;
uses crt;
const maxX=20;
      maxY=12;
      liczba_losowan=3;
      typy_kul=5;
      dlugosc_linii=5;
type typ_planszy=array[1..maxX,1..maxY] of integer;
var plansza:typ_planszy;
    odwiedzone:array[1..maxX,1..maxY] of boolean;
    i,j:integer;
    od_x,od_y,do_x,do_y:integer;
    pole:string[2];
    ruch_wykonany:boolean;

procedure losuj(var plansza:typ_planszy);
var x,y,co:integer;
begin
     repeat
          x:=random(MaxX)+1;
          y:=random(MaxY)+1;
     until (plansza[x,y]=0);
     plansza[x,y]:=random(typy_kul)+1;
end;

procedure namaluj_plansze(plansza:typ_planszy);
var i,j:integer;
begin
     for i:=1 to maxX do
     begin
          gotoxy(2+2*i,1);
          write(chr(96+i),'|');
     end;
     for j:=1 to maxY do
     begin
         gotoxy(1,2*j);
         write(j);
         gotoxy(3,2*j);
         write('|');
         gotoxy(1,2*j+1);
         for i:=1 to maxX*2+2 do
         write('-');
     end;
     for i:=1 to maxX do
     for j:=1 to maxY do
     begin
          gotoxy(2*i+2,2*j);
          case plansza[i,j] of
          5: write('*|');
          4: write('^|');
          3: write('$|');
          2: write('O|');
          1: write('X|');
          0: write(' |');
        end;
     end;
end;

function pelna(plansza:typ_planszy):boolean;
var p:boolean;
    i,j:integer;
begin
     p:=true;
     for i:=1 to maxX do
         for j:=1 to maxY do
             if (plansza[i,j]=0) then
                p:=false;
     pelna:=p;
end;

function ruch(od_x,od_y,biezace_x,biezace_y,do_x,do_y:integer):boolean;
(* Przyklad rozbudowanej funkcji rekurencyjnej *)
var r:boolean;
begin;
   if (biezace_x=do_x) and (biezace_y=do_y) then r:=true
   else
      if (plansza[od_x,od_y]=0) or (plansza[do_x,do_y]<>0) or odwiedzone[biezace_x,biezace_y] then r:=false
      else
      begin
           r:=false;
           odwiedzone[biezace_x,biezace_y]:=true;
           if biezace_x<>1 then
              if (plansza[biezace_x-1,biezace_y]=0) and (not odwiedzone[biezace_x-1,biezace_y]) then
                  if ruch(od_x,od_y,biezace_x-1,biezace_y,do_x,do_y) then r:=true;
           if not r then
           if biezace_y<>1 then
               if (plansza[biezace_x,biezace_y-1]=0) and (not odwiedzone[biezace_x,biezace_y-1]) then
                  if ruch(od_x,od_y,biezace_x,biezace_y-1,do_x,do_y) then r:=true;
           if not r then
           if biezace_x<>MaxX then
              if (plansza[biezace_x+1,biezace_y]=0) and (not odwiedzone[biezace_x+1,biezace_y]) then
                  if ruch(od_x,od_y,biezace_x+1,biezace_y,do_x,do_y) then r:=true;
           if not r then
           if biezace_y<>MaxY then
               if (plansza[biezace_x,biezace_y+1]=0)  and (not odwiedzone[biezace_x,biezace_y+1])then
                  if ruch(od_x,od_y,biezace_x,biezace_y+1,do_x,do_y) then r:=true;
       end;
   ruch:=r;
end;

procedure Wyczysc_Linie(var plansza:typ_planszy);
var i,j,k:integer;
    linia:boolean;
    poczatek_linii_x,poczatek_linii_y:integer;
    MinMax:integer;
begin
     for i:=1 to maxX do
         for j:=1 to MaxY-dlugosc_linii do
         begin
             linia:=true;
             for k:=2 to dlugosc_linii do
                 if abs(plansza[i,j+1])<>abs(plansza[i,j+k]) then
                    linia:=false;
             if linia then
                for k:=1 to dlugosc_linii do
                    plansza[i,j+k]:=-abs(plansza[i,j+k]);
         end;
     for j:=1 to maxY do
         for i:=1 to MaxX-dlugosc_linii do
         begin
             linia:=true;
             for k:=2 to dlugosc_linii do
                 if abs(plansza[i+1,j])<>abs(plansza[i+k,j]) then
                    linia:=false;
             if linia then
                for k:=1 to dlugosc_linii do
                    plansza[i+k,j]:=-abs(plansza[i+1,j]);
         end;
     if MaxX<MaxY then MinMax :=MaxX else MinMax:=MaxY;
     for j:=1 to MinMax-dlugosc_linii do
     for i:=1 to MinMax-dlugosc_linii do
         begin
             linia:=true;
             for k:=2 to dlugosc_linii do
                 if abs(plansza[i+1,j+1])<>abs(plansza[i+k,j+k]) then
                    linia:=false;
             if linia then
                for k:=1 to dlugosc_linii do
                    plansza[i+k,j+k]:=-abs(plansza[i+1,j+1]);
         end;
     for j:=1 to MinMax-dlugosc_linii do
     for i:=dlugosc_linii+1 to MinMax do
         begin
             linia:=true;
             for k:=2 to dlugosc_linii do
                 if abs(plansza[i-1,j+1])<>abs(plansza[i-k,j+k]) then
                    linia:=false;
             if linia then
                for k:=1 to dlugosc_linii do
                    plansza[i-k,j+k]:=-abs(plansza[i-1,j+1]);
         end;

     for i:=1 to MaxX do
     for j:=1 to MAxY do
         if plansza[i,j]<0 then plansza[i,j]:=0;
end;

begin
     randomize;
     clrscr;
     while true do
     begin
          for i:=1 to liczba_losowan do
          begin
              losuj(plansza);
              if pelna(plansza) then
              begin
                 writeln('Przegrales - plansza pelna');
                 halt;
              end;
          end;
          namaluj_plansze(plansza);
          repeat
                    ruch_wykonany:=false;
                    gotoxy(55,10);
                    write('Podaj wspolrzedne (od)');
                    gotoxy(55,12);
                    write('Podaj wspolrzedne (do)');
                    gotoxy(55,11);
                    write('   ');
                    gotoxy(55,13);
                    write('   ');
                    gotoxy(55,11);
                    read(pole);
                    if pole[1]='z' then halt;
                    od_x:=ord(pole[1])-96;
                    gotoxy(56,11);
                    readln(od_y);
                    gotoxy(55,13);
                    read(pole);
                    do_x:=ord(pole[1])-96;
                    gotoxy(56,13);
                    read(do_y);
                    for i:=1 to maxX do
                        for j:=1 to MaxY do
                            odwiedzone[i,j]:=false;
                    if ruch(od_x,od_y,od_x,od_y,do_x,do_y) then
                    begin
                         plansza[do_x,do_y]:=plansza[od_x,od_y];
                         plansza[od_x,od_y]:=0;
                         ruch_wykonany:=true;
                    end;
          until ruch_wykonany;
          readln;
          wyczysc_linie(plansza);
          namaluj_plansze(plansza);
    end;
end.
